package Tienda;

import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.*;

import java.util.*;

import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

public class ladron extends Agent {
	private static final long serialVersionUID = 1L;

	protected void setup() {

		SequentialBehaviour seqBehaviour = new SequentialBehaviour(){
			public int onEnd(){
				System.out.println("El segurata arresta al ladron");
				return super.onEnd();
			}
		};
		seqBehaviour.addSubBehaviour(new WakerBehaviour(this, 5) {
			protected void handleElapsedTimeout() {
				System.out
						.println("("
								+ getLocalName()
								+ ")"
								+ "Piensa que...\n\t\tHoy va ha ser un dia interesante...");
			}
		});
		seqBehaviour.addSubBehaviour(new WakerBehaviour(this, 100) {
			protected void handleElapsedTimeout() {
				System.out
						.println("("
								+ getLocalName()
								+ ")"
								+ "A quien se le habra caido este anillo... Me lo quedo");
			}
		});

		seqBehaviour.addSubBehaviour(new WakerBehaviour(this, 500) {
			protected void handleElapsedTimeout() {
				System.out
						.println("("
								+ getLocalName()
								+ ")"
								+ "Nadie lo echara de menos asi es que este libro tambien me lo guardo");
			}
		});
		seqBehaviour.addSubBehaviour(new WakerBehaviour(this, 200) {
			protected void handleElapsedTimeout() {
				System.out
						.println("("
								+ getLocalName()
								+ ")"
								+ "Ya esta por hoy, ahora me escapare por la puerta de atras...");
				ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
				msg.addReceiver(new AID("segurata", AID.ISLOCALNAME));
				msg.setContent("fuga");
				send(msg);
				ACLMessage msg1 = blockingReceive(MessageTemplate
						.MatchPerformative(ACLMessage.INFORM));
				if (msg1.getContent().equalsIgnoreCase("fuga")) {
					System.out.println("(" + getLocalName()
							+ ") Mierda me han pillado!!");
					doDelete();
				}
			}
		});
		addBehaviour(seqBehaviour);

	}

	protected void takeDown() {
		System.out.println("("+getLocalName()+") Te vas a enterar!");
		ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
		msg.addReceiver(new AID("segurata", AID.ISLOCALNAME));
		msg.setContent("fin");
		send(msg);
	}

}
